#
# disables the check: brp-java-repack-jars
# needed that the following error do not happen:
#  Unhandled exception: java.lang.RuntimeException: Bytecode jar contains
#  unexpected file META-INF/
#     in  (src/stage2/gen/NQP.nqp)
#
%define __jar_repack %{nil}

%global year 2014
%global month 04
%global parrot_version 6.1.0

%global PAR_LIB_DIR %{_libdir}/parrot/%{parrot_version}
%global parrot_dynext %{PAR_LIB_DIR}/dynext

Name:		nqp
Version:	0.0.%{year}.%{month}
Release:	2%{?dist}
Summary:	Not Quite Perl (6)

Group:		Development/Libraries
License:	Artistic 2.0 and ISC and WTFPL
URL:		https://github.com/perl6/nqp
Source0:	http://rakudo.org/downloads/nqp/nqp-%{year}.%{month}.tar.gz
Patch0:		use_libtommath.patch

BuildRequires:	readline-devel, gmp-devel, libicu-devel, libtommath-devel
BuildRequires:	perl(Test::Harness)
BuildRequires:	parrot >= %{parrot_version}
BuildRequires:	parrot-devel >= %{parrot_version}
BuildRequires:	parrot-tools >= %{parrot_version}

Requires:	parrot >= %{parrot_version}

%description
This is "Not Quite Perl" -- a compiler for quickly generating PIR routines
from Perl6-like code. The key feature of NQP is that it's
designed to be a very small compiler (as compared with, say, perl6
or Rakudo) and is focused on being a high-level way to create
compilers and libraries for virtual machines (such as the Parrot
Virtual Machine). Unlike a full-fledged implementation of Perl 6,
NQP strives to have as small a run-time footprint as it can, while
still providing a Perl 6 object model and regular expression engine
for the virtual machine.


#--

%package jvm
Summary:	Not Quite Perl (6) build on JVM
Group:		Development/Libraries

BuildArch:	noarch

BuildRequires:	perl(Text::ParseWords)
BuildRequires:	perl(Test::Harness)

BuildRequires:	jpackage-utils
BuildRequires:	java
BuildRequires:	java-devel

Requires:	java


%description jvm
Not Quite Perl (6) build on JVM

#--

%ifarch x86_64
%package moar
Summary:	Not Quite Perl (6) build on MoarVM
Group:		Development/Libraries

BuildRequires:	moarvm
BuildRequires:	moarvm-devel

Requires:	moarvm


%description moar
Not Quite Perl (6) build on MoarVM
%endif

#--



%prep
%setup -q -n %{name}-%{year}.%{month}
#
# see https://bugzilla.redhat.com/show_bug.cgi?id=1077812 why this files
# are removed
#
# The upstream libtommath doesn't have the conversion from and to
# float/double that NQP needs. bn_mp_(get|set)_long.c are extentions of the
# origin libtommath source. The header files are needed to build.
rm `find 3rdparty/libtommath -type f ! -name '*long.c' -a ! -name '*.h'`
#
%patch0 -p0


%build
%ifarch x86_64
%{__perl} Configure.pl --has-libtommath --backends=parrot,jvm,moar --prefix=%{_usr}
%else
%{__perl} Configure.pl --has-libtommath --backends=parrot,jvm --prefix=%{_usr}
%endif

CFLAGS="$RPM_OPT_FLAGS -fPIC" %{__make} # %{?_smp_mflags}


%install
%{__make} install DESTDIR=$RPM_BUILD_ROOT

# Force executable permission on shared objects so they get stripped
%{__chmod} 755 $RPM_BUILD_ROOT%{parrot_dynext}/nqp*.so


%check
%ifarch x86_64
  # The tests fail on i686 and armv7hl architecture
  #    t/serialization/01-basic.t ............ 
  #    Failed 12/1355 subtests 
  #    t/serialization/02-types.t ............ ok
#  %{?!_without_tests: make test}
%endif


%files
%doc CREDITS LICENSE README.pod docs examples
%{_bindir}/nqp-p

# The unversioned shared system library files are needed for the essential work
# of the nqp executable, otherwise the executing of nqp fails
# with error message "PARROT VM: Could not load bytecode ..."
%{parrot_dynext}/nqp_group.so
%{parrot_dynext}/nqp_ops.so
%{parrot_dynext}/nqp_bigint_ops.so
%{parrot_dynext}/nqp_dyncall_ops.so

%{PAR_LIB_DIR}/languages/nqp
%{PAR_LIB_DIR}/library/ModuleLoader.pbc
%{PAR_LIB_DIR}/include/nqp_const.pir

%{_includedir}/parrot/%{parrot_version}/dynpmc/pmc_*


%files jvm
%{_bindir}/nqp-j
%{_bindir}/eval-client.pl
%dir %{_usr}/languages
%dir %{_usr}/languages/nqp
%dir %{_usr}/languages/nqp/lib
%{_usr}/languages/nqp/lib/*.jar
%{_usr}/languages/nqp/runtime


%ifarch x86_64
%files moar
%{_bindir}/nqp-m
%dir %{_usr}/languages
%dir %{_usr}/languages/nqp
%dir %{_usr}/languages/nqp/lib
%{_usr}/languages/nqp/lib/*.moarvm
%endif



%changelog
* Sun Aug 17 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.0.2014.04-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_22_Mass_Rebuild

* Fri Aug 15 2014 Gerd Pokorra <gp@zimt.uni-siegen.de> 0.0.2014.04-1
- add subpackage moar
- update to 20014.04

* Fri Apr 04 2014 Gerd Pokorra <gp@zimt.uni-siegen.de> 0.0.2014.03-4
- add subpackage jvm

* Fri Apr 04 2014 Gerd Pokorra <gp@zimt.uni-siegen.de> 0.0.2014.03-3
- add a comment while not all libtommath source files are deleted

* Thu Apr 03 2014 Gerd Pokorra <gp@zimt.uni-siegen.de> 0.0.2014.03-2
- add deleting of libtommath source files in prep section

* Thu Apr 03 2014 Gerd Pokorra <gp@zimt.uni-siegen.de> 0.0.2014.03-1
- update to 20014.03
- run tests only on x86_64 architecture
- add flag has-libtommath to Configure.pl and a patch for it

* Wed Feb 19 2014 Gerd Pokorra <gp@zimt.uni-siegen.de> 0.0.2014.01-1
- update to 20014.01
- rebuild for new ICU
- the executable is renamed from nqp to nqp-p

* Fri Oct 04 2013 Gerd Pokorra <gp@zimt.uni-siegen.de> 0.0.2013.09-1
- update to 20013.09
- add docs and examples directories to dokumentation files

* Thu Jan 31 2013 Gerd Pokorra <gp@zimt.uni-siegen.de> 0.0.2013.01-1
- update to 2013.01
- add additional header files
- change the source to the new URL

* Wed Nov 07 2012 Gerd Pokorra <gp@zimt.uni-siegen.de> 0.0.2012.10-1
- update to 2012.10

* Wed Nov  7 2012 Peter Robinson <pbrobinson@fedoraproject.org> 0.0.2012.08.1-2
- compile with distro CFLAGs and -fPIC

* Mon Sep 03 2012 Gerd Pokorra <gp@zimt.uni-siegen.de> 0.0.2012.08.1-1
- update to 2012.08.1

* Tue Aug 14 2012 Gerd Pokorra <gp@zimt.uni-siegen.de> 0.0.2012.07-5
- added check section
- removed clean section
- added ISC to License tag

* Mon Aug 13 2012 Gerd Pokorra <gp@zimt.uni-siegen.de> 0.0.2012.07-4
- changed License tag  
- removed defattr

* Mon Aug 13 2012 Gerd Pokorra <gp@zimt.uni-siegen.de> 0.0.2012.07-3
- replaced "define" with "global"
- removed BuildRoot tag

* Wed Aug 08 2012 Gerd Pokorra <gp@zimt.uni-siegen.de> 0.0.2012.07-2
- fixed description error from rpmlint

* Tue Aug 07 2012 Gerd Pokorra <gp@zimt.uni-siegen.de> 0.0.2012.07-1
- did not build with _smp_mflags
- initial .spec file created
